from pyloadl import *

"""

   Displays information on the LoadLeveler cluster

"""

print "LoadLeveler version : %s" % ll_version()

query = ll_query(CLUSTERS)
b = ll_set_request(query, QUERY_ALL, [""], ALL_DATA)

cluster, num, error = ll_get_objs(query, LL_CM, "")
print "GetObjects: Num Objs - %d, Error - %d\n" % (num, error)

while PyCObjValid(cluster):

	schedtype = ll_get_data(cluster, LL_ClusterSchedulerType)
	print "Scheduler Type          : %s" %  schedtype

	enfsub = ll_get_data(cluster, LL_ClusterEnforceSubmission)
	print "Enforced Submission     : %s\n" % bool(enfsub)

	enfrescnt = ll_get_data(cluster, LL_ClusterEnforcedResourceCount)
	print "Enforced Resource Count : %d" % enfrescnt
	enfres = ll_get_data(cluster, LL_ClusterEnforcedResources)
	print "Enforced Resources      : %s\n" % enfres

	defrescnt = ll_get_data(cluster,LL_ClusterDefinedResourceCount)
	print "Defined Resource Count  : %d" % defrescnt
	defres = ll_get_data(cluster,LL_ClusterDefinedResources)
	print "Defined Resources       : %s\n" % defres

	schedrescnt = ll_get_data(cluster,LL_ClusterSchedulingResourceCount)
	print "Scheduled Resource Count: %d" % schedrescnt
	schedres = ll_get_data(cluster, LL_ClusterSchedulingResources)
	print "Scheduled Resources     : %s\n" % schedres

	print "Resource Info :\n"
	resource = ll_get_data(cluster, LL_ClusterGetFirstResource)
	while PyCObjValid(resource):

		name = ll_get_data(resource, LL_ResourceName)
		init_val = ll_get_data(resource, LL_ResourceInitialValue)
		avail_val = ll_get_data(resource, LL_ResourceAvailableValue)
		print "Name: %s, Inital : %d, Available : %d" % (name, init_val, avail_val)
		resource = ll_get_data(cluster, LL_ClusterGetNextResource)
    
	cluster = ll_next_obj(query)

#
# Free up space allocated by LoadLeveler
#

ll_free_objs(cluster)
ll_deallocate(query)
